// PictureStreamDoc.cpp : implementation of the CPictureStreamDoc class
//

#include "stdafx.h"
#include "PictureStream.h"

#include "PictureStreamDoc.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CPictureStreamDoc

IMPLEMENT_DYNCREATE(CPictureStreamDoc, COleDocument)

BEGIN_MESSAGE_MAP(CPictureStreamDoc, COleDocument)
	//{{AFX_MSG_MAP(CPictureStreamDoc)
	ON_COMMAND(ID_PICTURE_ADD, OnPictureAdd)
	ON_UPDATE_COMMAND_UI(ID_PICTURE_ADD, OnUpdatePictureAdd)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CPictureStreamDoc construction/destruction

CPictureStreamDoc::CPictureStreamDoc()
{
	EnableCompoundFile();
}

CPictureStreamDoc::~CPictureStreamDoc()
{
}

static const CString GetCurrentDirectory()
{
	TCHAR buf[MAX_PATH] = {0};
	::GetCurrentDirectory(sizeof(buf),buf);
	return CString(buf);
}

BOOL CPictureStreamDoc::OnNewDocument()
{
	CString strCurDir = GetCurrentDirectory();

	bool bFound = false;

	CString strFile(strCurDir + "/res/Default.p2f");
	
	CFileStatus status;
	if(CFile::GetStatus(strFile,status))
	{
		bFound = true;
	}
	

	if(bFound)
	{
		return OnOpenDocument(strFile);
	}
	else
	{
		if (!COleDocument::OnNewDocument())
			return FALSE;
		return TRUE;
	}
}



/////////////////////////////////////////////////////////////////////////////
// CPictureStreamDoc serialization

void CPictureStreamDoc::Serialize(CArchive& ar)
{
	CWaitCursor wait;
	COleDocument::Serialize(ar);
	if (ar.IsStoring())
	{
		m_objects.WriteToStorage(m_lpRootStg); 
	}
	else
	{
		m_objects.ReadFromStorage(m_lpRootStg); 
		m_objects.DeselectAll();
	}
}

/////////////////////////////////////////////////////////////////////////////
// CPictureStreamDoc diagnostics

#ifdef _DEBUG
void CPictureStreamDoc::AssertValid() const
{
	COleDocument::AssertValid();
}

void CPictureStreamDoc::Dump(CDumpContext& dc) const
{
	COleDocument::Dump(dc);
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CPictureStreamDoc commands

void CPictureStreamDoc::OnPictureAdd() 
{
	CPictureObj* pObj = new CPictureObj;
	if(!pObj->CreateFromFile(CPoint(10,10)))
	{
		delete pObj;
		return;
	}
	m_objects.AddHead(pObj);
	SetModifiedFlag(TRUE);
	UpdateAllViews(NULL,HINT_UPDATE_WINDOW);
}


void CPictureStreamDoc::OnUpdatePictureAdd(CCmdUI* pCmdUI) 
{
	pCmdUI->Enable(true);
}
